    SUBROUTINE Warning(routine, msg, file, line, unit)

! This routine prints a warning message and goes on
! Inspired  from Die in Siesta 3.1 

!----------------------------------------------------------------------
!  Copyright 2003-2014 Ecole Normale Supérieure de Lyon, 
!  Centre National de la Recherche Scientifique,
!  Université Claude Bernard Lyon 1. All rights reserved.
!
!  This work is registered with the Agency for the Protection of Programs 
!  as IDDN.FR.001.100009.000.S.P.2014.000.30625
!
!  Authors: P. Fleurat-Lessard, P. Dayal
!  Contact: optnpath@gmail.com
!
! This file is part of "Opt'n Path".
!
!  "Opt'n Path" is free software: you can redistribute it and/or modify
!  it under the terms of the GNU Affero General Public License as
!  published by the Free Software Foundation, either version 3 of the License,
!  or (at your option) any later version.
!
!  "Opt'n Path" is distributed in the hope that it will be useful,
!  but WITHOUT ANY WARRANTY; without even the implied warranty of
!
!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!  GNU Affero General Public License for more details.
!
!  You should have received a copy of the GNU Affero General Public License
!  along with "Opt'n Path". If not, see <http://www.gnu.org/licenses/>.
!
! Contact The Office of Technology Licensing, valorisation@ens-lyon.fr,
! for commercial licensing opportunities.
!----------------------------------------------------------------------

      Use VarTypes
      Use io_module

      implicit none


  INTERFACE
     function valid(string) result (isValid)
       CHARACTER(*), intent(in) :: string
       logical                  :: isValid
     END function VALID

  END INTERFACE
!--------------------------------------------------------------- Input Variables
      character(len=*), intent(in)           :: routine, msg
      character(len=*), intent(in), optional :: file
      integer(KINT), intent(in), optional      :: line, unit

!--------------------------------------------------------------- Local Variables
      integer(KINT)                            :: warning_unit

      LOGICAL ::  Debug

!------------------------------------------------------------------------- BEGIN
      debug=valid('warning')

      if (debug) Call Header('Entering Warning')
      if (PRESENT(unit)) then
        warning_unit = unit
      else
        warning_unit = IOOUT
      endif

      write(warning_unit,'(a)') '*************************************************************'
      write(warning_unit,'(a)') '* WARNING *'
      write(warning_unit,'(a)') ' '
      write(warning_unit,'(3a)') TRIM(routine), ': ', TRIM(msg)
      write(warning_unit,'(a)') ' '
      if (PRESENT(file)) write(warning_unit,'(5x,2a)') 'File: ', file
      if (PRESENT(line)) write(warning_unit,'(5x,a,i5)') 'Line: ', line
      write(warning_unit,'(a)') '*************************************************************'

      if (debug) Call Header('Exiting Warning')

    END SUBROUTINE warning

